'-- PowerBasic Console Compiler (PBCC) source code to generate truly random and unique numbers.
'-- Accompanied by a function to generate highly randomized seeds: TheSeeder by Ion Saliu.
'-- This source code works accurately without modification in PBCC version 4.04;
'-- the programmer is entirely responsible for transportation to other platforms or PBCC versions.
#DEBUG ERROR ON
OPTION EXPLICIT
DEFLNG A-Z
DECLARE SUB FindIndex ()
DECLARE SUB FindCombo ()
DECLARE FUNCTION Combine(N AS LONG, M AS LONG) AS EXT
GLOBAL K AS LONG
GLOBAL V AS LONG
GLOBAL GU AS LONG
GLOBAL LI AS EXT
GLOBAL L AS EXT
GLOBAL R AS EXT
GLOBAL P1 AS LONG
GLOBAL R1 AS LONG
GLOBAL Num() AS LONG
GLOBAL C() AS LONG
GLOBAL CSN AS EXT
GLOBAL TOT AS EXT
GLOBAL I AS LONG
GLOBAL j AS LONG
GLOBAL y AS LONG
GLOBAL RE1() AS STRING
GLOBAL VS AS STRING
GLOBAL KS AS STRING
GLOBAL LST AS STRING
GLOBAL NumS AS STRING
GLOBAL Choice7 AS STRING
GLOBAL AN AS STRING



          FUNCTION PBMAIN() AS LONG

MyTop:
COLOR 14, 3
INPUT FLUSH
CURSOR OFF

CLS
LOCATE 1, 2: PRINT " (C) Copyright 1988-2009 Ion Saliu. All rights reserved "
LOCATE 2, 2: PRINT " LexicographicAlgorithms.EXE ~ version 1.0, October 2009 ~ SALIU.COM "
LOCATE 4, 2: PRINT "This program calculates the index (rank) of a given combination and,"
LOCATE 5, 2: PRINT "conversely, finds the combination for a specified index (rank)."
LOCATE 7, 2: PRINT "The 1st algorithm (C) was discovered by B. P. Buckles and M. Lybanon (1977);"
LOCATE 8, 2: PRINT "see File #515 at http://www.netlib.org/toms/ (written in FORTRAN)."
LOCATE 10, 2: PRINT "The 2nd algorithm (I) was discovered by Ion Saliu (2001)."
LOCATE 12, 2: PRINT " * Read comprehensive presentations at SALIU.COM:"
LOCATE 13, 5: PRINT "saliu.com/lexicographic.html and saliu.com/bbs/messages/348.html"
LOCATE 15, 2: PRINT " ** The complete lexicographic order software: LexicographicSets.EXE."

LOCATE 18, 2: PRINT "͸"
LOCATE 19, 2: PRINT "                           Select the function:                             "
LOCATE 20, 2: PRINT "Ĵ"
LOCATE 21, 2: PRINT " C      Combination for Index      I       Index for Combination        "
LOCATE 22, 2: PRINT ";"
LOCATE 23, 2: PRINT "                      X    Exit This Fantastic Program    "
LOCATE 24, 2: PRINT "                     ;"

  WHILE NOT INSTAT: WEND             ' Wait for keypress

LOCATE 19, 51: Choice7$ = INKEY$:  Choice7$ = UCASE$( Choice7$)
PRINT Choice7$

 SELECT CASE Choice7$


        CASE "C"
        CALL FindCombo
        GOTO MyTop

        CASE "I"
        CALL FindIndex
        GOTO MyTop

        CASE "X"
        CLS
        CURSOR ON
        EXIT FUNCTION

        CASE ELSE
        BEEP
        GOTO MyTop

 END SELECT


        END FUNCTION




SUB FindCombo

MyTop:
ON ERROR GOTO erpro
INPUT FLUSH
CURSOR ON

CLS
LOCATE 2, 5: PRINT " This function finds the COMBINATION for a given index"
LOCATE 3, 5: PRINT " in cases of N items taken M at a time (e.g. lotto combinations)."
LOCATE 6, 5: PRINT " *** Defaults:"
LOCATE 7, 5: PRINT " The biggest number in the set (N): 49"
LOCATE 8, 5: PRINT " Numbers per combination (M): 6"
LOCATE 9, 5: PRINT " Index: Half point ('total combinations' divided by 2)."

LOCATE 11, 14: PRINT CHR$(201); STRING$(49, 205); CHR$(187)
LOCATE 12, 14: PRINT CHR$(186);
LOCATE 12, 64: PRINT CHR$(186)
LOCATE 13, 14: PRINT CHR$(200); STRING$(49, 205); CHR$(188)
LOCATE 12, 15: LINE INPUT " Enter the biggest number -> ", VS
 IF LEN(VS)=0 THEN
     V=49
     ELSE
     V=VAL(VS)
 END IF

     IF V<=0 THEN
     V=49
     END IF

LOCATE 15, 14: PRINT CHR$(201); STRING$(49, 205); CHR$(187)
LOCATE 16, 14: PRINT CHR$(186);
LOCATE 16, 64: PRINT CHR$(186)
LOCATE 17, 14: PRINT CHR$(200); STRING$(49, 205); CHR$(188)
LOCATE 16, 15: LINE INPUT " How many numbers per combination -> ", KS
 IF LEN(KS)=0 THEN
     K=6
     ELSE
     K=VAL(KS)
 END IF

     IF K<=0 THEN
     K=6
     END IF


TOT = Combine(V, K)

LOCATE 19, 5: PRINT "Total combinations for your settings:"; TOT
LOCATE 20, 5: PRINT "Default index:"; TOT \ 2

LOCATE 22, 14: PRINT CHR$(201); STRING$(49, 205); CHR$(187)
LOCATE 23, 14: PRINT CHR$(186);
LOCATE 23, 64: PRINT CHR$(186)
LOCATE 24, 14: PRINT CHR$(200); STRING$(49, 205); CHR$(188)
LOCATE 23, 15: LINE INPUT " Enter the index you want -> ", LST
 IF LEN(LST)=0 THEN
     L=INT(TOT / 2)
     ELSE
     L=VAL(LST)
 END IF

 IF L > TOT THEN
    L = TOT
    ELSEIF L < 1 THEN
    L = 1
 END IF

CLS
LOCATE 10, 14: PRINT CHR$(201); STRING$(40, 205); CHR$(187);
LOCATE 11, 14: PRINT CHR$(186);
LOCATE 12, 14: PRINT CHR$(186);
LOCATE 11, 55: PRINT CHR$(186);
LOCATE 12, 55: PRINT CHR$(186);
LOCATE 13, 14: PRINT CHR$(200); STRING$(40, 205); CHR$(188);
LOCATE 11, 20: PRINT "      Doing the works...   "

    REDIM C(K)

      LI = 0
      P1 = K - 1

    FOR I = 1 TO P1

        C(I) = 0
        IF I <> 1 THEN
            C(I) = C(I - 1)
        END IF

   1101 C(I) = C(I) + 1

        R1 = Combine(V - C(I), K - I)

        LI = LI + R1

        IF LI < L THEN
            GOTO 1101
        END IF

        LI = LI - R1


    NEXT I

        C(K) = C(P1) + L - LI

1201 CLOSE:CLS

LOCATE 8, 5: PRINT CHR$(201); STRING$(68, 205); CHR$(187);
LOCATE 9, 5: PRINT CHR$(186);
LOCATE 9, 74: PRINT CHR$(186);
LOCATE 10, 5: PRINT CHR$(186);
LOCATE 10, 74: PRINT CHR$(186);
LOCATE 11, 5: PRINT CHR$(186);
LOCATE 11, 74: PRINT CHR$(186);
LOCATE 12, 5: PRINT CHR$(186);
LOCATE 12, 74: PRINT CHR$(186);
LOCATE 13, 5: PRINT CHR$(186);
LOCATE 13, 74: PRINT CHR$(186);
LOCATE 14, 5: PRINT CHR$(186);
LOCATE 14, 74: PRINT CHR$(186);
LOCATE 15, 5: PRINT CHR$(186);
LOCATE 15, 74: PRINT CHR$(186);
LOCATE 16, 5: PRINT CHR$(186);
LOCATE 16, 74: PRINT CHR$(186);
 LOCATE 9, 7: PRINT "Set of type"; K;"from";V;"has"; Combine(V, K); "total combinations."
 LOCATE 11, 7: PRINT "The set of index"; L
     LOCATE 12, 7: PRINT "is: "
     LOCATE 14, 7
     FOR i = 1 TO K
     PRINT FORMAT$(C(i), "* ##");
    NEXT i

LOCATE 16, 21: PRINT " Run the function again (Y/N)?"
LOCATE 17, 5: PRINT CHR$(200); STRING$(68, 205); CHR$(188);

  AN$ = "": AN$ = WAITKEY$
      IF AN$ = "n" OR AN$ = "N" THEN
          CURSOR ON
          EXIT SUB
          ELSE
          ON ERROR GOTO 0
          GOTO MyTop
      END IF

                EXIT SUB

erpro:
CLS
        y = ERR
   SELECT CASE ERRCLEAR
        CASE 9
        LOCATE 13, 5
        PRINT "You probably attempted to use more data than "
        LOCATE 15, 5
        PRINT "the maximum number of lines the file consists of."
        LOCATE 17, 5
        PRINT "Or you might have modified a WS or report file."
        LOCATE 19, 25
        PRINT "Press <Spacebar> to terminate the program..."
        WAITKEY$
          CURSOR ON
          EXIT SUB
        CASE 53
        LOCATE 13, 5
        PRINT "The file name specified could not be found on the indicated drive."
        LOCATE 15, 5
        PRINT "Type the file name accurately, including the path."
        LOCATE 17, 25
        PRINT "Press <Spacebar> to resume..."
        WAITKEY$
    CASE 64
        LOCATE 13, 5
        PRINT "Bad file name - "
        LOCATE 15, 5
        PRINT "The file name specified contains invalid characters,"
        LOCATE 17, 5
        PRINT "or NO characters at all; i.e. an empty string."
        LOCATE 19, 25
        PRINT "Press <Spacebar> to resume..."
        WAITKEY$
    CASE 71
        LOCATE 13, 5
        PRINT "The door of a floppy disk drive is open,"
        LOCATE 15, 5
        PRINT "or there is no disk in the indicated drive."
        LOCATE 17, 25
        PRINT "Press <Spacebar> to resume..."
        WAITKEY$
    CASE 76
        LOCATE 13, 5
        PRINT "The path you specified doesn't exist."
        LOCATE 15, 5
        PRINT "Type the file name accurately, including the path."
        LOCATE 17, 5
        PRINT "The path is not needed if the file is in current directory."
        LOCATE 19, 25
        PRINT "Press <Spacebar> to resume..."
        WAITKEY$
    CASE ELSE
        LOCATE 10, 5
        'y = ERR
        PRINT "Problem unforseen by the deEveloper!"
        LOCATE 12, 5
        PRINT "It could be related to the file you specified;"
        LOCATE 14, 5
        PRINT "the file could be corrupt or not in text format;"
        LOCATE 16, 5
        PRINT "or you didn't type anything at all as file name."
        LOCATE 18, 15
        PRINT "*** If you want to report the bug -> ERROR #"; y
        LOCATE 20, 25
        PRINT "Press <Spacebar> to terminate the program..."
        WAITKEY$
          CURSOR ON
          EXIT SUB
  END SELECT
  RESUME MyTop

END SUB




SUB FindIndex

MyTop:
ON ERROR GOTO erpro
INPUT FLUSH
CURSOR ON

CLS
LOCATE 2, 5: PRINT " This function finds the INDEX for a given combination "
LOCATE 3, 5: PRINT " in cases of N items taken M at a time (e.g. lotto combinations)."
LOCATE 6, 5: PRINT " *** Defaults:"
LOCATE 7, 5: PRINT " The biggest number in the set (N): 49"
LOCATE 8, 5: PRINT " Numbers per combination (M): 6"

LOCATE 11, 14: PRINT CHR$(201); STRING$(49, 205); CHR$(187)
LOCATE 12, 14: PRINT CHR$(186);
LOCATE 12, 64: PRINT CHR$(186)
LOCATE 13, 14: PRINT CHR$(200); STRING$(49, 205); CHR$(188)
LOCATE 12, 15: LINE INPUT " Enter the biggest number -> ", VS
 IF LEN(VS)=0 THEN
     V=49
     ELSE
     V=VAL(VS)
 END IF

     IF V<=0 THEN
     V=49
     END IF

LOCATE 15, 14: PRINT CHR$(201); STRING$(49, 205); CHR$(187)
LOCATE 16, 14: PRINT CHR$(186);
LOCATE 16, 64: PRINT CHR$(186)
LOCATE 17, 14: PRINT CHR$(200); STRING$(49, 205); CHR$(188)
LOCATE 16, 15: LINE INPUT " How many numbers per line -> ", KS
 IF LEN(KS)=0 THEN
     K=6
     ELSE
     K=VAL(KS)
 END IF

     IF K<=0 THEN
     K=6
     END IF


REDIM C(K)
REDIM Num(K)    'the numbers in the combination

LOCATE 20, 5: PRINT " Type the"; K; "numbers in the combination in ascending order."
LOCATE 21, 5: PRINT " Make sure you don't type the same number more than once!"
LOCATE 22, 5: PRINT " Press [ENTER] after each number."

PRINT
   FOR j=1 TO K
 LOCATE , 10:  PRINT "   Enter number";j;
 LINE INPUT " -> ", NumS
 Num(j) = VAL(NumS)
   NEXT j

   FOR i=1 TO K-1:  FOR j=i+1 TO K
     IF Num(i) > Num(j) THEN
     SWAP Num(i), Num(j)
     END IF
   NEXT j: NEXT i

CLS
LOCATE 10, 14: PRINT CHR$(201); STRING$(40, 205); CHR$(187);
LOCATE 11, 14: PRINT CHR$(186);
LOCATE 12, 14: PRINT CHR$(186);
LOCATE 11, 55: PRINT CHR$(186);
LOCATE 12, 55: PRINT CHR$(186);
LOCATE 13, 14: PRINT CHR$(200); STRING$(40, 205); CHR$(188);
LOCATE 11, 20: PRINT "      Doing the works...   "

         LI = 0
         CSN = 0
         P1 = K - 1

    FOR I = 1 TO P1

        C(I) = 0
        IF I <> 1 THEN C(I) = C(I - 1)
    2001 C(I) = C(I) + 1

        R1=Combine(V - C(I), K - I)  'call the combination calculator

        LI = LI + R1

        IF C(I) < Num(I) THEN GOTO 2001

        LI = LI - R1

    NEXT I


        CSN = LI + Num(K) - Num(P1)  'combination sequence number


1201 CLOSE:CLS
LOCATE 8, 5: PRINT CHR$(201); STRING$(68, 205); CHR$(187);
LOCATE 9, 5: PRINT CHR$(186);
LOCATE 9, 74: PRINT CHR$(186);
LOCATE 10, 5: PRINT CHR$(186);
LOCATE 10, 74: PRINT CHR$(186);
LOCATE 11, 5: PRINT CHR$(186);
LOCATE 11, 74: PRINT CHR$(186);
LOCATE 12, 5: PRINT CHR$(186);
LOCATE 12, 74: PRINT CHR$(186);
LOCATE 13, 5: PRINT CHR$(186);
LOCATE 13, 74: PRINT CHR$(186);
LOCATE 14, 5: PRINT CHR$(186);
LOCATE 14, 74: PRINT CHR$(186);
LOCATE 15, 5: PRINT CHR$(186);
LOCATE 15, 74: PRINT CHR$(186);
LOCATE 16, 5: PRINT CHR$(186);
LOCATE 16, 74: PRINT CHR$(186);
 LOCATE 9, 7: PRINT "Set of type"; K;"from";V;"has"; Combine(V, K); "total combinations."
 LOCATE 11, 7: PRINT "The index (rank) of combination "
     LOCATE 12, 7
     FOR i = 1 TO K
     PRINT FORMAT$(Num(i), "* ##");
    NEXT i
     LOCATE 14, 8: PRINT "is: "; CSN

LOCATE 16, 21: PRINT " Run the function again (Y/N)?"
LOCATE 17, 5: PRINT CHR$(200); STRING$(68, 205); CHR$(188);

  AN$ = "": AN$ = WAITKEY$
      IF AN$ = "n" OR AN$ = "N" THEN
          CURSOR ON
          EXIT SUB
          ELSE
          ON ERROR GOTO 0
          GOTO MyTop
      END IF

                EXIT SUB

erpro:
CLS
        y = ERR
   SELECT CASE ERRCLEAR
        CASE 9
        LOCATE 13, 5
        PRINT "You probably attempted to use more data than "
        LOCATE 15, 5
        PRINT "the maximum number of lines the file consists of."
        LOCATE 17, 5
        PRINT "Or you might have modified a WS or report file."
        LOCATE 19, 25
        PRINT "Press <Spacebar> to terminate the program..."
        WAITKEY$
          CURSOR ON
          EXIT SUB
        CASE 53
        LOCATE 13, 5
        PRINT "The file name specified could not be found on the indicated drive."
        LOCATE 15, 5
        PRINT "Type the file name accurately, including the path."
        LOCATE 17, 25
        PRINT "Press <Spacebar> to resume..."
        WAITKEY$
    CASE 64
        LOCATE 13, 5
        PRINT "Bad file name - "
        LOCATE 15, 5
        PRINT "The file name specified contains invalid characters,"
        LOCATE 17, 5
        PRINT "or NO characters at all; i.e. an empty string."
        LOCATE 19, 25
        PRINT "Press <Spacebar> to resume..."
        WAITKEY$
    CASE 71
        LOCATE 13, 5
        PRINT "The door of a floppy disk drive is open,"
        LOCATE 15, 5
        PRINT "or there is no disk in the indicated drive."
        LOCATE 17, 25
        PRINT "Press <Spacebar> to resume..."
        WAITKEY$
    CASE 76
        LOCATE 13, 5
        PRINT "The path you specified doesn't exist."
        LOCATE 15, 5
        PRINT "Type the file name accurately, including the path."
        LOCATE 17, 5
        PRINT "The path is not needed if the file is in current directory."
        LOCATE 19, 25
        PRINT "Press <Spacebar> to resume..."
        WAITKEY$
    CASE ELSE
        LOCATE 10, 5
        'y = ERR
        PRINT "Problem unforseen by the deEveloper!"
        LOCATE 12, 5
        PRINT "It could be related to the file you specified;"
        LOCATE 14, 5
        PRINT "the file could be corrupt or not in text format;"
        LOCATE 16, 5
        PRINT "or you didn't type anything at all as file name."
        LOCATE 18, 15
        PRINT "*** If you want to report the bug -> ERROR #"; y
        LOCATE 20, 25
        PRINT "Press <Spacebar> to terminate the program..."
        WAITKEY$
          CURSOR ON
          EXIT SUB
  END SELECT
  RESUME MyTop

END SUB





FUNCTION Combine(N AS LONG, M AS LONG) AS EXT

DIM iC AS LONG
DIM jC AS LONG
DIM FA AS EXT
DIM va AS EXT

 REM *** This function calculates the total number of combinations ***
 REM *** 'N taken M at a time'

     FA = 1
     FOR iC = 1 TO M: FA = FA * iC: NEXT iC
     va = 1
     FOR jC = (N - M + 1) TO N: va = va * jC: NEXT jC
     Combine = va / FA

END FUNCTION
